// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic','ngCordova','ionic-letter-avatar','toastr','ngAnimate','starter.controllers', 'starter.services','googlechart'])

.run(function($ionicPlatform, $rootScope, $state, User,$ionicPopup,$cordovaDevice,toastr,$cordovaNetwork) {

  // Display the login view if the user is not logged in



  $rootScope.$on('$stateChangeStart', function(event, toState) {    

   var mobile_no = window.localStorage.getItem('mobile_no');
   var islogedin = window.localStorage.getItem('islogedin');
    
    document.addEventListener("offline", onOffline, false);       
    function onOffline() 
    {  
   // alert("ahdsjfdjf");     
    $state.go("offline");
    }

    if (!User.isLoggedIn()  && toState.name !== 'login') {
      event.preventDefault();
      $state.go('login');
    }
    console.log("first "+User.isLoggedIn());
    console.log("second "+User.mpinlogin());
     //if( toState.name !== 'dashboard')
    // //{
    //   $state.go('dashboard');
    // }

    if (User.isLoggedIn()  && !User.mpinlogin() && toState.name !== 'offline'  && toState.name !== 'mpin'  && toState.name !== 'before' && toState.name !== 'signout' && toState.name !== 'list')                                                          
     {
      document.addEventListener("deviceready", onDeviceReady, false);
      function onDeviceReady() 
     {    
      var serial = device.serial;
       window.localStorage.setItem('serial',serial);      
     }
      event.preventDefault();
      //alert("jhsdfds");
      $state.go('mpin');
    }
   
   

  });

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

  });
})
.config(function(toastrConfig) {
  angular.extend(toastrConfig, {
    autoDismiss: true,
    containerId: 'toast-container',
    maxOpened: 1,    
    newestOnTop: true,
    positionClass: 'toast-bottom-center',
    preventDuplicates: false,
    preventOpenDuplicates: false,
    target: 'body'
  });
})
.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider
 
  .state('login', {
    url: '/',
    templateUrl : 'templates/login.html',
    controller  : 'LoginCtrl'
  })

  .state('before', {
    url: '/before',    
    templateUrl: 'templates/otp.html',
    controller: 'OtpCtrl'    
  })

  .state('mpin', {
    url: '/mpin',   
    templateUrl: 'templates/pincode.html',
    controller : 'UnlockController'    
  })

 .state('list', {
    url: '/list',   
    templateUrl: 'templates/designation_list.html',
    controller : 'ListController'  
  })

  .state('signout', {
    url: '/signout',   
    controller: 'SignoutCtrl'     
  })

    .state('logout', {
      url: '/logout',
      controller: 'LogoutCtrl'    
    })
   
   .state('offline', {
      url: '/offline',     
      templateUrl: 'templates/off_line.html',
      controller : 'OfflineController'     
    })

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl',
    
  })
  
  
 
  .state('app.dashboard', {
      url: '/dashboard',
       //reload:true,
      views: {
        'menuContent': {
          templateUrl: 'templates/dashboard.html',
          controller : 'DashCtrl'
         
        }
      }
    })
   
//GEO Details Menu Start--------------------------------------------------------------------
   .state('app.geo', {
    url: "/geo_menu",
    reload:true,
    //abstract: true,
    views: {
      'menuContent': {
        templateUrl: "templates/geo_menu.html"
      }
    }
  })
  .state('app.geo.geo_revenue', {
    url: '/geo_revenue',
    
    views: {
      'geo_revenue': {
        templateUrl: 'templates/geo_revenue.html',
        controller : 'GeoCtrl'
        
      }
    }
  })
  .state('app.geo.geo_transaction', {
    url: '/geo_transaction',
   
    views: {
      'geo_transaction': {
        templateUrl: 'templates/geo_transaction.html',
       controller : 'GeoTransCtrl'
        
      }
    }
  })
//Geo Details End--------------------------------------------------------------------

//Bank Menu Start--------------------------------------------------------------------
   .state('app.bank', {
      url: '/bank_menu',     
       abstract: true,
      views: {
        'menuContent': {
          templateUrl: 'templates/bank_menu.html',
       //   controller : 'BankCtrl'
         
        }
      }
    })
   .state('app.bank.bank_revenue', {
    url: '/bank_revenue',
    
    views: {
      'bank_revenue': {
        templateUrl: 'templates/bank_revenue.html',
        controller : 'BankCtrl'
        
      }
    }
  })
  .state('app.bank.bank_transaction', {
    url: '/bank_transaction',
   
    views: {
      'bank_transaction': {
        templateUrl: 'templates/bank_transaction.html',
       controller : 'BankTransCtrl'
        
      }
    }
  })
//Bank Details End--------------------------------------------------------------------

//User Menu Start--------------------------------------------------------------------

   .state('app.staff', {
      url: '/staff_menu',     
       abstract: true,
      views: {
        'menuContent': {
          templateUrl: 'templates/staff_menu.html',
       //   controller : 'BankCtrl'
         
        }
      }
    })
   .state('app.staff.staff_revenue', {
    url: '/staff_revenue',
    
    views: {
      'staff_revenue': {
        templateUrl: 'templates/staff_revenue.html',
        controller : 'UserCtrl'
        
      }
    }
  })
  .state('app.staff.staff_transaction', {
    url: '/staff_transaction',
   
    views: {
      'staff_transaction': {
        templateUrl: 'templates/staff_transaction.html',
       controller : 'StaffTransCtrl'
        
      }
    }
  })
//User Details End--------------------------------------------------------------------

  .state('app.bca', {
    url: "/bca",
    abstract: true,
    views: {
      'menuContent': {
        templateUrl: "templates/bca_menu.html"
      }
    }
  })

  .state('app.bca.profile', {
    url: "/bca_profile/:bca_id",
    views: {
      'bca_profile': {
        templateUrl: "templates/bca_profile.html",
        controller : 'BcaCtrl'
      }
    }
  })

  .state('app.bca.revenue', {
    url: "/bca_revenue/:bca_id",
    views: {
      'bca_revenue': {
        templateUrl: "templates/bca_revenue.html",
        controller : 'BcaRevenueCtrl'
        
      }
    }
  })     
  .state('app.bca.transaction', {
    url: "/bca_transaction/:bca_id",
    views: {
      'bca_transaction': {
        templateUrl: "templates/bca_transaction.html",
        controller : 'BcaTransactionCtrl'
        
      }
    }
  })    
  .state('app.single', {
    url: '/playlists/:playlistId',
    views: {
      'menuContent': {
        templateUrl: 'templates/playlist.html',
        controller: 'PlaylistCtrl'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
 // $urlRouterProvider.otherwise('/app/geo_menu/geo_revenue');
 $urlRouterProvider.otherwise('/mpin');

  
});
